## pcl 1.12.1+dfsg

=== CMakeLists.txt ===
### ---[ PCL global CMake
cmake_minimum_required(VERSION 3.10 FATAL_ERROR)

if(POLICY CMP0074)
  # 1. Remove with 3.12.4.
  # 2. Remove search paths with *_ROOT since they will be automatically checked
  cmake_policy(SET CMP0074 NEW)
endif()

# Set target C++ standard and required compiler features
set(CMAKE_CXX_STANDARD 14 CACHE STRING "The target C++ standard. PCL requires C++14 or higher.")
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(PCL_CXX_COMPILE_FEATURES cxx_std_14)

set(CMAKE_CUDA_STANDARD 14 CACHE STRING "The target CUDA/C++ standard. PCL requires CUDA/C++ 14 or higher.")
set(CMAKE_CUDA_STANDARD_REQUIRED ON)

set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "possible configurations" FORCE)

# In case the user does not setup CMAKE_BUILD_TYPE, assume it's RelWithDebInfo
if("${CMAKE_BUILD_TYPE}" STREQUAL "")
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type default to RelWithDebInfo, set to Release to improve performance" FORCE)
endif()

project(PCL VERSION 1.12.1)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

### ---[ Find universal dependencies
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/" ${CMAKE_MODULE_PATH})

# ---[ Include pkgconfig
include(FindPkgConfig)

if(WIN32 AND NOT MINGW)
  set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "Add postfix to target for Debug build.")
  set(CMAKE_RELEASE_POSTFIX "" CACHE STRING "Add postfix to target for Release build.")
  set(CMAKE_RELWITHDEBINFO_POSTFIX "rd" CACHE STRING "Add postfix to target for RelWithDebInfo build.")
  set(CMAKE_MINSIZEREL_POSTFIX "s" CACHE STRING "Add postfix to target for MinSizeRel build")
endif()

# Update the documentation string of CMAKE_BUILD_TYPE for GUIs
set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)

# Compiler identification
# Define a variable CMAKE_COMPILER_IS_X where X is the compiler short name.
# Note: CMake automatically defines one for GNUCXX, nothing to do in this case.
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANG 1)
elseif(__COMPILER_PATHSCALE)
  set(CMAKE_COMPILER_IS_PATHSCALE 1)
elseif(MSVC)
  set(CMAKE_COMPILER_IS_MSVC 1)
elseif(MINGW)
  set(CMAKE_COMPILER_IS_MINGW 1)
endif()

# Create a variable with expected default CXX flags
# This will be used further down the road to check if the user explicitly provided CXX flags
if(CMAKE_COMPILER_IS_MSVC)
  set(CMAKE_CXX_FLAGS_DEFAULT "/DWIN32 /D_WINDOWS /W3 /GR /EHsc")
else()
  set(CMAKE_CXX_FLAGS_DEFAULT "")
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_verbosity.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_targets.cmake")
include("${PCL_SOURCE_DIR}/cmake/pcl_options.cmake")
include("${PCL_SOURCE_DIR}/cmake/clang-format.cmake")

if(${PCL_ENABLE_CCACHE})
  include (UseCompilerCache)
  UseCompilerCache(ccache REQUIRED)
endif()

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_SOURCE_DIR}/cmake/custom_output.sh")
endif()

# check for SSE flags
include("${PCL_SOURCE_DIR}/cmake/pcl_find_sse.cmake")
if(PCL_ENABLE_SSE AND "${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
  PCL_CHECK_FOR_SSE()
endif()

# check for AVX flags
if(PCL_ENABLE_AVX AND "${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
  include("${PCL_SOURCE_DIR}/cmake/pcl_find_avx.cmake")
  PCL_CHECK_FOR_AVX()
endif()

# ---[ Unix/Darwin/Windows specific flags
if(CMAKE_COMPILER_IS_GNUCXX)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7)
      string(APPEND CMAKE_CXX_FLAGS " -Wabi=11")
    else()
      string(APPEND CMAKE_CXX_FLAGS " -Wabi")
    endif()
    string(APPEND CMAKE_CXX_FLAGS " -Wall -Wextra -Wno-unknown-pragmas -fno-strict-aliasing -Wno-format-extra-args -Wno-sign-compare -Wno-invalid-offsetof -Wno-conversion ${SSE_FLAGS} ${AVX_FLAGS}")
  endif()

  if(PCL_WARNINGS_ARE_ERRORS)
    string(APPEND CMAKE_CXX_FLAGS " -Werror -fno-strict-aliasing")
  endif()

  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "" AND NOT CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed")
  endif()

  if(WIN32)
    if(PCL_SHARED_LIBS)
      string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--export-all-symbols -Wl,--enable-auto-import")
      if(MINGW)
        add_definitions("-DBOOST_THREAD_USE_LIB")
        string(APPEND CMAKE_SHARED_LINKER_FLAGS " -Wl,--allow-multiple-definition")
      endif()
    else()
      add_definitions("-DBOOST_LIB_DIAGNOSTIC -DBOOST_THREAD_USE_LIB")
    endif()
  endif()
endif()

if(CMAKE_COMPILER_IS_MSVC)
  add_definitions("-DBOOST_ALL_NO_LIB -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -DPCL_ONLY_CORE_POINT_TYPES ${SSE_DEFINITIONS}")
  
  if("${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    string(APPEND CMAKE_CXX_FLAGS " /fp:precise /wd4800 /wd4521 /wd4251 /wd4275 /wd4305 /wd4355 ${SSE_FLAGS} ${AVX_FLAGS} /bigobj")

    # Add extra code generation/link optimizations
    if(CMAKE_MSVC_CODE_LINK_OPTIMIZATION AND (NOT BUILD_CUDA) AND (NOT BUILD_GPU))
      string(APPEND CMAKE_CXX_FLAGS_RELEASE " /GL")
      string(APPEND CMAKE_SHARED_LINKER_FLAGS_RELEASE " /LTCG /OPT:REF")
      string(APPEND CMAKE_EXE_LINKER_FLAGS_RELEASE " /LTCG")
    else()
      set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -Xcompiler=/bigobj")
      
      message("Global optimizations /GL has been turned off, as it doesn't work with nvcc/thrust")
    endif()
    # /MANIFEST:NO") # please, don't disable manifest generation, otherwise crash at start for vs2008

    if(PCL_WARNINGS_ARE_ERRORS)
      string(APPEND CMAKE_CXX_FLAGS " /WX")
    endif()

    include(ProcessorCount)
    ProcessorCount(CPUCores)
    set(MSVC_MP ${CPUCores} CACHE STRING "Number of simultaneously running compilers (0 = automatic detection by MSVC). See documentation of /MP flag.")
    if (CMAKE_VERSION VERSION_LESS 3.11.0)
      # Usage of COMPILE_LANGUAGE generator expression for MSVC in add_compile_options requires at least CMake 3.11, see https://gitlab.kitware.com/cmake/cmake/issues/17435
      if(MSVC_MP EQUAL 0)
        # MSVC_MP is 0 in case the information cannot be determined by ProcessorCount => fallback
        string(APPEND CMAKE_C_FLAGS " /MP")
        string(APPEND CMAKE_CXX_FLAGS " /MP")
      elseif(MSVC_MP GREATER 1)
        string(APPEND CMAKE_C_FLAGS " /MP${MSVC_MP}")
        string(APPEND CMAKE_CXX_FLAGS " /MP${MSVC_MP}")
      endif()      
    else()      
      if(MSVC_MP EQUAL 0)
        # MSVC_MP is 0 in case the information cannot be determined by ProcessorCount => fallback
        # Generator expression is necessary to limit /MP flag to C/CXX, so flag will be not set to e.g. CUDA (see https://gitlab.kitware.com/cmake/cmake/issues/17535)
        add_compile_options($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:/MP>)
      elseif(MSVC_MP GREATER 1)
        add_compile_options($<$<OR:$<COMPILE_LANGUAGE:C>,$<COMPILE_LANGUAGE:CXX>>:/MP${MSVC_MP}>)
      endif()
    endif()
  endif()

  if(CMAKE_GENERATOR STREQUAL "Ninja")
    string(APPEND CMAKE_C_FLAGS " /FS")
    string(APPEND CMAKE_CXX_FLAGS " /FS")
  endif()
endif()

if(CMAKE_COMPILER_IS_PATHSCALE)
  if("${CMAKE_CXX_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    set(CMAKE_CXX_FLAGS "-Wno-uninitialized -zerouv -mp")
  endif()
  if("${CMAKE_SHARED_LINKER_FLAGS}" STREQUAL "")
    set(CMAKE_SHARED_LINKER_FLAGS "-mp")
  endif()
endif()

if(CMAKE_COMPILER_IS_CLANG)
  if("${CMAKE_C_FLAGS}" STREQUAL "${CMAKE_CXX_FLAGS_DEFAULT}")
    set(CMAKE_C_FLAGS "-Qunused-arguments")
  endif()
  if("${CMAKE_CXX_FLAGS}" STREQUAL "")
    set(CMAKE_CXX_FLAGS "-ftemplate-depth=1024 -Qunused-arguments -Wno-invalid-offsetof ${SSE_FLAGS} ${AVX_FLAGS}") # Unfortunately older Clang versions do not have this: -Wno-unnamed-type-template-args
    if(APPLE AND WITH_CUDA AND CUDA_FOUND)
      string(APPEND CMAKE_CXX_FLAGS " -stdlib=libstdc++")
    endif()
  endif()
  set(CLANG_LIBRARIES "stdc++")
endif()

if(CMAKE_COMPILER_IS_MINGW)
  add_definitions(-DPCL_ONLY_CORE_POINT_TYPES)
endif()

include("${PCL_SOURCE_DIR}/cmake/pcl_utils.cmake")
DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

if(WIN32)
  set(PCL_RESOURCES_DIR "${PCL_SOURCE_DIR}/resources")
  set(PCL_POINTCLOUDS_DIR "${PCL_RESOURCES_DIR}/pointclouds")
endif()

set(PCL_OUTPUT_LIB_DIR "${PCL_BINARY_DIR}/${LIB_INSTALL_DIR}")
set(PCL_OUTPUT_BIN_DIR "${PCL_BINARY_DIR}/${BIN_INSTALL_DIR}")
make_directory("${PCL_OUTPUT_LIB_DIR}")
make_directory("${PCL_OUTPUT_BIN_DIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
if(WIN32)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_BIN_DIR}")
  foreach(config ${CMAKE_CONFIGURATION_TYPES})
    string(TOUPPER ${config} CONFIG)
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_LIB_DIR}")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
    # ---[ Windows requires DLLs (shared libraries) to be installed in the same directory as executables
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CONFIG} "${PCL_OUTPUT_BIN_DIR}")
  endforeach()
else()
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PCL_OUTPUT_LIB_DIR}")
endif()

# Check if the current generator is an IDE.
check_if_ide(CMAKE_GENERATOR_IS_IDE)

# Add an "uninstall" target
if(CMAKE_GENERATOR_IS_IDE)
  set(UNINSTALL_TARGET_NAME UNINSTALL)
else()
  set(UNINSTALL_TARGET_NAME uninstall)
endif()
configure_file("${PCL_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
               "${PCL_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
add_custom_target(${UNINSTALL_TARGET_NAME} "${CMAKE_COMMAND}" -P
                  "${PCL_BINARY_DIR}/uninstall_target.cmake")

###
# this is copy paste form http://www.itk.org/Wiki/CMake_RPATH_handling
# in order to always make a full statement RPATH
###
set(CMAKE_SKIP_BUILD_RPATH  FALSE)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}" is_system_dir)
if("${is_system_dir}" STREQUAL "-1")
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
endif()

### ---[ Find universal dependencies

# OpenMP (optional)
option(WITH_OPENMP "Build with parallelization using OpenMP" TRUE)
if(WITH_OPENMP)
  find_package(OpenMP COMPONENTS C CXX)
endif()
if(OpenMP_FOUND)
  string(APPEND CMAKE_C_FLAGS " ${OpenMP_C_FLAGS}")
  string(APPEND CMAKE_CXX_FLAGS " ${OpenMP_CXX_FLAGS}")
  if(${CMAKE_VERSION} VERSION_LESS "3.7")
    message(STATUS "Found OpenMP")
  else()
    # We could use OpenMP_CXX_VERSION starting from CMake 3.9, but this value is only available on first run of CMake (see https://gitlab.kitware.com/cmake/cmake/issues/19150),
    # so we use always OpenMP_CXX_SPEC_DATE, which is available since CMake 3.7.
    message(STATUS "Found OpenMP, spec date ${OpenMP_CXX_SPEC_DATE}")
  endif()
  if(MSVC)
    if(MSVC_VERSION EQUAL 1900)
      set(OPENMP_DLL VCOMP140)
    elseif(MSVC_VERSION MATCHES "^191[0-9]$")
      set(OPENMP_DLL VCOMP140)
    elseif(MSVC_VERSION MATCHES "^192[0-9]$")
      set(OPENMP_DLL VCOMP140)
    elseif(MSVC_VERSION MATCHES "^193[0-9]$")
      set(OPENMP_DLL VCOMP140)
    endif()
    if(OPENMP_DLL)
      string(APPEND CMAKE_SHARED_LINKER_FLAGS_DEBUG " /DELAYLOAD:${OPENMP_DLL}D.dll")
      string(APPEND CMAKE_SHARED_LINKER_FLAGS_RELEASE " /DELAYLOAD:${OPENMP_DLL}.dll")
    else()
      message(WARNING "Delay loading flag for OpenMP DLL is invalid.")
    endif()
  endif()
else()
  message(STATUS "Not found OpenMP")
endif()

# Threads (required)
find_package(Threads REQUIRED)

# Eigen (required)
find_package(Eigen 3.1 REQUIRED)
include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})

# FLANN (required)

=== 2d/CMakeLists.txt ===
set(SUBSYS_NAME 2d)
set(SUBSYS_DESC "Point cloud 2d")
set(SUBSYS_DEPS common filters)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS vtk)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/convolution_2d.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/convolution.h"
  "include/pcl/${SUBSYS_NAME}/kernel.h"
  "include/pcl/${SUBSYS_NAME}/edge.h"
  "include/pcl/${SUBSYS_NAME}/morphology.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/convolution.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/kernel.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/edge.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/morphology.hpp"
)

if(${VTK_FOUND})
  set(VTK_IO_TARGET_LINK_LIBRARIES vtkCommon vtkWidgets vtkIO vtkImaging)
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

set(LIB_NAME "pcl_${SUBSYS_NAME}")
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} HEADER_ONLY)

#Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== apps/CMakeLists.txt ===
set(SUBSYS_NAME apps)
set(SUBSYS_DESC "Application examples/samples that show how PCL works")
set(SUBSYS_DEPS common geometry io filters sample_consensus segmentation visualization kdtree features surface octree registration keypoints tracking search recognition ml stereo 2d)
set(SUBSYS_OPT_DEPS openni vtk ${QTX})

set(DEFAULT FALSE)
set(REASON "Disabled by default")
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS ${SUBSYS_OPT_DEPS})

if(NOT build)
  return()
endif()

#Enable cmakes QT auto features.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# to be filled with all targets the apps subsystem
set(PCL_APPS_ALL_TARGETS)

include_directories("${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}/include")

PCL_ADD_EXECUTABLE(pcl_test_search_speed COMPONENT ${SUBSYS_NAME} SOURCES src/test_search.cpp)
target_link_libraries(pcl_test_search_speed pcl_common pcl_io pcl_search pcl_kdtree pcl_visualization)

PCL_ADD_EXECUTABLE(pcl_nn_classification_example COMPONENT ${SUBSYS_NAME} SOURCES src/nn_classification_example.cpp)
target_link_libraries(pcl_nn_classification_example pcl_common pcl_io pcl_features pcl_kdtree)

PCL_ADD_EXECUTABLE(pcl_pyramid_surface_matching COMPONENT ${SUBSYS_NAME} SOURCES src/pyramid_surface_matching.cpp)
target_link_libraries(pcl_pyramid_surface_matching pcl_common pcl_io pcl_features pcl_registration pcl_filters)

PCL_ADD_EXECUTABLE(pcl_statistical_multiscale_interest_region_extraction_example COMPONENT ${SUBSYS_NAME} SOURCES src/statistical_multiscale_interest_region_extraction_example.cpp)
target_link_libraries(pcl_statistical_multiscale_interest_region_extraction_example pcl_common pcl_io pcl_features pcl_filters)

if(LIBUSB_FOUND)
  PCL_ADD_EXECUTABLE(pcl_dinast_grabber COMPONENT ${SUBSYS_NAME} SOURCES src/dinast_grabber_example.cpp)
  target_link_libraries(pcl_dinast_grabber pcl_common pcl_visualization pcl_io)
endif()

if(VTK_FOUND)
  set(incs "include/pcl/${SUBSYS_NAME}/render_views_tesselated_sphere.h")
  set(srcs "src/render_views_tesselated_sphere.cpp")

  PCL_ADD_EXECUTABLE(pcl_ppf_object_recognition COMPONENT ${SUBSYS_NAME} SOURCES src/ppf_object_recognition.cpp)
  target_link_libraries(pcl_ppf_object_recognition pcl_common pcl_io pcl_filters pcl_features pcl_registration pcl_visualization pcl_sample_consensus pcl_segmentation)

  PCL_ADD_EXECUTABLE(pcl_multiscale_feature_persistence_example COMPONENT ${SUBSYS_NAME} SOURCES src/multiscale_feature_persistence_example.cpp)
  target_link_libraries(pcl_multiscale_feature_persistence_example pcl_common pcl_io pcl_filters pcl_features pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_surfel_smoothing_test COMPONENT ${SUBSYS_NAME} SOURCES src/surfel_smoothing_test.cpp)
  target_link_libraries(pcl_surfel_smoothing_test pcl_common pcl_io pcl_surface pcl_filters pcl_features pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_feature_matching COMPONENT ${SUBSYS_NAME} SOURCES src/feature_matching.cpp)
  target_link_libraries(pcl_feature_matching pcl_common pcl_io pcl_registration pcl_keypoints pcl_sample_consensus pcl_visualization pcl_search pcl_features pcl_kdtree pcl_surface pcl_segmentation)

  PCL_ADD_EXECUTABLE(pcl_convolve COMPONENT ${SUBSYS_NAME} SOURCES src/convolve.cpp)
  target_link_libraries(pcl_convolve pcl_common pcl_filters pcl_io pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_pcd_organized_multi_plane_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/pcd_organized_multi_plane_segmentation.cpp)
  target_link_libraries(pcl_pcd_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

  if(QHULL_FOUND)
    PCL_ADD_EXECUTABLE(pcl_pcd_select_object_plane COMPONENT ${SUBSYS_NAME} SOURCES src/pcd_select_object_plane.cpp)
    target_link_libraries(pcl_pcd_select_object_plane pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_surface)
  endif()

  PCL_ADD_EXECUTABLE(pcl_pcd_organized_edge_detection COMPONENT ${SUBSYS_NAME} SOURCES src/pcd_organized_edge_detection.cpp)
  target_link_libraries(pcl_pcd_organized_edge_detection pcl_common pcl_io pcl_features pcl_visualization)

  PCL_ADD_EXECUTABLE(pcl_face_trainer COMPONENT ${SUBSYS_NAME} SOURCES src/face_detection/face_trainer.cpp)
  target_link_libraries(pcl_face_trainer pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree)

  PCL_ADD_EXECUTABLE(pcl_fs_face_detector COMPONENT ${SUBSYS_NAME} SOURCES src/face_detection//filesystem_face_detection.cpp BUNDLE)
  target_link_libraries(pcl_fs_face_detector pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree)

  PCL_ADD_EXECUTABLE(pcl_stereo_ground_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/stereo_ground_segmentation.cpp)
  target_link_libraries(pcl_stereo_ground_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features pcl_stereo)

  if(QT_FOUND AND HAVE_QVTK)
    # Manual registration demo
    PCL_ADD_EXECUTABLE(pcl_manual_registration
      COMPONENT
      ${SUBSYS_NAME}
      SOURCES
      include/pcl/apps/manual_registration.h
      src/manual_registration/manual_registration.cpp
      src/manual_registration/manual_registration.ui
      BUNDLE)
      
    target_link_libraries(pcl_manual_registration pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QTX}::Widgets)

    PCL_ADD_EXECUTABLE(pcl_pcd_video_player
      COMPONENT
      ${SUBSYS_NAME}
      SOURCES
      include/pcl/apps/pcd_video_player.h
      src/pcd_video_player/pcd_video_player.cpp
      src/pcd_video_player/pcd_video_player.ui
      BUNDLE)
    
    target_link_libraries(pcl_pcd_video_player pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QTX}::Widgets)
  endif()

  if(WITH_OPENNI)
    PCL_ADD_EXECUTABLE(pcl_openni_fast_mesh COMPONENT ${SUBSYS_NAME} SOURCES src/openni_fast_mesh.cpp BUNDLE)
    target_link_libraries(pcl_openni_fast_mesh pcl_common pcl_io pcl_visualization pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_voxel_grid COMPONENT ${SUBSYS_NAME} SOURCES src/openni_voxel_grid.cpp BUNDLE)
    target_link_libraries(pcl_openni_voxel_grid pcl_common pcl_io pcl_filters pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_octree_compression COMPONENT ${SUBSYS_NAME} SOURCES src/openni_octree_compression.cpp BUNDLE)
    target_link_libraries(pcl_openni_octree_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)

    if(HAVE_PNG)
    PCL_ADD_EXECUTABLE(pcl_openni_organized_compression COMPONENT ${SUBSYS_NAME} SOURCES src/openni_organized_compression.cpp BUNDLE)
    target_link_libraries(pcl_openni_organized_compression pcl_common pcl_io pcl_filters pcl_visualization pcl_octree)
    endif()

    PCL_ADD_EXECUTABLE(pcl_openni_shift_to_depth_conversion COMPONENT ${SUBSYS_NAME} SOURCES src/openni_shift_to_depth_conversion.cpp BUNDLE)
    target_link_libraries(pcl_openni_shift_to_depth_conversion pcl_common pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_mobile_server COMPONENT ${SUBSYS_NAME} SOURCES src/openni_mobile_server.cpp)
    target_link_libraries(pcl_openni_mobile_server pcl_common pcl_io pcl_filters pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_planar_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_planar_segmentation.cpp BUNDLE)
    target_link_libraries(pcl_openni_planar_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus)

    PCL_ADD_EXECUTABLE(pcl_openni_organized_multi_plane_segmentation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_organized_multi_plane_segmentation.cpp BUNDLE)
    target_link_libraries(pcl_openni_organized_multi_plane_segmentation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_features)

    PCL_ADD_EXECUTABLE(pcl_openni_ii_normal_estimation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_ii_normal_estimation.cpp BUNDLE)
    target_link_libraries(pcl_openni_ii_normal_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_feature_persistence COMPONENT ${SUBSYS_NAME} SOURCES src/openni_feature_persistence.cpp BUNDLE)
    target_link_libraries(pcl_openni_feature_persistence pcl_common pcl_io pcl_filters pcl_visualization pcl_features)

    PCL_ADD_EXECUTABLE(pcl_openni_mls_smoothing COMPONENT ${SUBSYS_NAME} SOURCES src/openni_mls_smoothing.cpp BUNDLE)
    target_link_libraries(pcl_openni_mls_smoothing pcl_common pcl_io pcl_surface pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_change_viewer COMPONENT ${SUBSYS_NAME} SOURCES src/openni_change_viewer.cpp BUNDLE)
    target_link_libraries(pcl_openni_change_viewer pcl_common pcl_io pcl_kdtree pcl_octree pcl_visualization pcl_filters)

    PCL_ADD_EXECUTABLE(pcl_openni_uniform_sampling COMPONENT ${SUBSYS_NAME} SOURCES src/openni_uniform_sampling.cpp BUNDLE)
    target_link_libraries(pcl_openni_uniform_sampling pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface pcl_keypoints)

    PCL_ADD_EXECUTABLE(pcl_openni_boundary_estimation COMPONENT ${SUBSYS_NAME} SOURCES src/openni_boundary_estimation.cpp BUNDLE)
    target_link_libraries(pcl_openni_boundary_estimation pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_organized_edge_detection COMPONENT ${SUBSYS_NAME} SOURCES src/openni_organized_edge_detection.cpp BUNDLE)
    target_link_libraries(pcl_openni_organized_edge_detection pcl_common pcl_io pcl_features pcl_visualization)

    PCL_ADD_EXECUTABLE(pcl_openni_face_detector COMPONENT ${SUBSYS_NAME} SOURCES src/face_detection//openni_face_detection.cpp src/face_detection//openni_frame_source.cpp BUNDLE)
    target_link_libraries(pcl_openni_face_detector pcl_features pcl_recognition pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_surface pcl_keypoints pcl_ml pcl_search pcl_kdtree)

    if(QT_FOUND AND HAVE_QVTK)
      # OpenNI Passthrough application demo
      PCL_ADD_EXECUTABLE(pcl_openni_passthrough
        COMPONENT
          ${SUBSYS_NAME}
        SOURCES
          include/pcl/apps/openni_passthrough.h
          src/openni_passthrough.cpp
          src/openni_passthrough.ui)
          
      target_link_libraries(pcl_openni_passthrough pcl_common pcl_io pcl_filters pcl_visualization ${QTX}::Widgets)

      list(APPEND CMAKE_AUTOUIC_SEARCH_PATHS "src")

      # OpenNI Organized Connected Component application demo
      PCL_ADD_EXECUTABLE(pcl_organized_segmentation_demo
        COMPONENT
          ${SUBSYS_NAME}
        SOURCES
          include/pcl/apps/organized_segmentation_demo_qt.h
          include/pcl/apps/organized_segmentation_demo.h
          src/organized_segmentation_demo.cpp
          src/organized_segmentation_demo.ui
        BUNDLE)
      target_link_libraries(pcl_organized_segmentation_demo pcl_common pcl_io pcl_visualization pcl_segmentation pcl_features pcl_surface ${QTX}::Widgets)

    endif()

    if(QHULL_FOUND)
    PCL_ADD_EXECUTABLE(pcl_openni_3d_convex_hull COMPONENT ${SUBSYS_NAME} SOURCES src/openni_3d_convex_hull.cpp BUNDLE)
    target_link_libraries(pcl_openni_3d_convex_hull pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

    PCL_ADD_EXECUTABLE(pcl_openni_3d_concave_hull COMPONENT ${SUBSYS_NAME} SOURCES src/openni_3d_concave_hull.cpp BUNDLE)
    target_link_libraries(pcl_openni_3d_concave_hull pcl_common pcl_io pcl_filters pcl_visualization pcl_segmentation pcl_sample_consensus pcl_features pcl_surface)

=== common/CMakeLists.txt ===
set(SUBSYS_NAME common)
set(SUBSYS_DESC "Point cloud common library")
set(SUBSYS_DEPS)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS eigen boost)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(range_image_incs
  include/pcl/range_image/bearing_angle_image.h
  include/pcl/range_image/range_image.h
  include/pcl/range_image/range_image_planar.h
  include/pcl/range_image/range_image_spherical.h
)

set(range_image_incs_impl
  include/pcl/range_image/impl/range_image.hpp
  include/pcl/range_image/impl/range_image_planar.hpp
  include/pcl/range_image/impl/range_image_spherical.hpp
)

set(range_image_srcs
  src/bearing_angle_image.cpp
  src/range_image.cpp
  src/range_image_planar.cpp
)

set(srcs
  src/point_types.cpp
  src/pcl_base.cpp
  src/PCLPointCloud2.cpp
  src/io.cpp
  src/common.cpp
  src/correspondence.cpp
  src/distances.cpp
  src/parse.cpp
  src/poses_from_matches.cpp
  src/print.cpp
  src/projection_matrix.cpp
  src/time_trigger.cpp
  src/gaussian.cpp
  src/colors.cpp
  src/feature_histogram.cpp
  ${range_image_srcs}
)

set(incs
  include/pcl/correspondence.h
  include/pcl/memory.h
  include/pcl/exceptions.h
  include/pcl/pcl_base.h
  include/pcl/pcl_exports.h
  include/pcl/pcl_macros.h
  include/pcl/types.h
  include/pcl/point_cloud.h
  include/pcl/point_struct_traits.h
  include/pcl/point_traits.h
  include/pcl/type_traits.h
  include/pcl/point_types_conversion.h
  include/pcl/point_representation.h
  include/pcl/point_types.h
  include/pcl/for_each_type.h
  include/pcl/pcl_tests.h
  include/pcl/cloud_iterator.h
  include/pcl/TextureMesh.h
  include/pcl/sse.h
  include/pcl/PCLPointField.h
  include/pcl/PCLPointCloud2.h
  include/pcl/PCLImage.h
  include/pcl/PCLHeader.h
  include/pcl/ModelCoefficients.h
  include/pcl/PolygonMesh.h
  include/pcl/Vertices.h
  include/pcl/PointIndices.h
  include/pcl/register_point_struct.h
  include/pcl/conversions.h
  include/pcl/make_shared.h
)

set(common_incs
  include/pcl/common/boost.h
  include/pcl/common/angles.h
  include/pcl/common/bivariate_polynomial.h
  include/pcl/common/centroid.h
  include/pcl/common/concatenate.h
  include/pcl/common/common.h
  include/pcl/common/common_headers.h
  include/pcl/common/distances.h
  include/pcl/common/eigen.h
  include/pcl/common/copy_point.h
  include/pcl/common/io.h
  include/pcl/common/file_io.h
  include/pcl/common/intersections.h
  include/pcl/common/norms.h
  include/pcl/common/piecewise_linear_function.h
  include/pcl/common/polynomial_calculations.h
  include/pcl/common/poses_from_matches.h
  include/pcl/common/time.h
  include/pcl/common/time_trigger.h
  include/pcl/common/transforms.h
  include/pcl/common/transformation_from_correspondences.h
  include/pcl/common/vector_average.h
  include/pcl/common/pca.h
  include/pcl/common/point_tests.h
  include/pcl/common/synchronizer.h
  include/pcl/common/utils.h
  include/pcl/common/geometry.h
  include/pcl/common/gaussian.h
  include/pcl/common/spring.h
  include/pcl/common/intensity.h
  include/pcl/common/random.h
  include/pcl/common/generate.h
  include/pcl/common/projection_matrix.h
  include/pcl/common/colors.h
  include/pcl/common/feature_histogram.h
)

set(common_incs_impl
  include/pcl/common/impl/angles.hpp
  include/pcl/common/impl/bivariate_polynomial.hpp
  include/pcl/common/impl/centroid.hpp
  include/pcl/common/impl/common.hpp
  include/pcl/common/impl/eigen.hpp
  include/pcl/common/impl/intersections.hpp
  include/pcl/common/impl/copy_point.hpp
  include/pcl/common/impl/io.hpp
  include/pcl/common/impl/file_io.hpp
  include/pcl/common/impl/norms.hpp
  include/pcl/common/impl/piecewise_linear_function.hpp
  include/pcl/common/impl/polynomial_calculations.hpp
  include/pcl/common/impl/pca.hpp
  include/pcl/common/impl/transforms.hpp
  include/pcl/common/impl/transformation_from_correspondences.hpp
  include/pcl/common/impl/vector_average.hpp
  include/pcl/common/impl/gaussian.hpp
  include/pcl/common/impl/spring.hpp
  include/pcl/common/impl/intensity.hpp
  include/pcl/common/impl/random.hpp
  include/pcl/common/impl/generate.hpp
  include/pcl/common/impl/projection_matrix.hpp
  include/pcl/common/impl/accumulators.hpp
)

set(impl_incs
  include/pcl/impl/pcl_base.hpp
  include/pcl/impl/instantiate.hpp
  include/pcl/impl/point_types.hpp
  include/pcl/impl/cloud_iterator.hpp
)

set(tools_incs
  include/pcl/console/parse.h
  include/pcl/console/print.h
  include/pcl/console/time.h
)

set(kissfft_incs
  include/pcl/common/fft/_kiss_fft_guts.h
  include/pcl/common/fft/kiss_fft.h
  include/pcl/common/fft/kiss_fftr.h
)

set(kissfft_srcs
  src/fft/kiss_fft.c
  src/fft/kiss_fftr.c
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${kissfft_srcs} ${incs} ${common_incs} ${impl_incs} ${tools_incs} ${kissfft_incs} ${common_incs_impl} ${range_image_incs} ${range_image_incs_impl})

target_link_libraries(${LIB_NAME} Boost::boost)

if(MSVC AND NOT (MSVC_VERSION LESS 1915))
  # MSVC resolved a byte alignment issue in compiler version 15.9
  # We get this due to using Eigen objects and allocating those objects with make_shared
  # It has to be public so that everything linking with common has this definition too
  target_compile_definitions(${LIB_NAME} PUBLIC _ENABLE_EXTENDED_ALIGNED_STORAGE)
endif()

PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" common ${common_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/fft ${kissfft_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" common/impl ${common_incs_impl})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" impl ${impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" console ${tools_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image ${range_image_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" range_image/impl ${range_image_incs_impl})

=== doc/CMakeLists.txt ===
include(CMakeDependentOption)

cmake_dependent_option(WITH_TUTORIALS "Build tutorials (requires Sphinx)" FALSE "WITH_DOCS" FALSE)
if(WITH_TUTORIALS)
  find_package(Sphinx)
  if(SPHINX_FOUND)
    set(SPHINX_CACHE_DIR "${CMAKE_CURRENT_BINARY_DIR}/_doctrees")
    set(SPHINX_HTML_FILE_SUFFIX "html" CACHE STRING "Suffix (extension) of the HTML files generated by Sphinx")
  endif()
endif()

add_subdirectory(doxygen)
add_subdirectory(advanced)
add_subdirectory(tutorials)

=== examples/CMakeLists.txt ===
set(SUBSYS_NAME examples)
set(SUBSYS_DESC "PCL examples")
set(SUBSYS_DEPS common io features search kdtree octree filters keypoints segmentation sample_consensus outofcore stereo geometry surface)

set(DEFAULT FALSE)
set(REASON "Code examples are disabled by default.")
PCL_SUBSYS_OPTION(build ${SUBSYS_NAME} ${SUBSYS_DESC} ${DEFAULT} ${REASON})
PCL_SUBSYS_DEPEND(build ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})

if(NOT build)
  return()
endif()

# this variable will filled with all targets added with pcl_add_example
set(PCL_EXAMPLES_ALL_TARGETS)

include_directories(${PCL_INCLUDE_DIRS})
# This looks for all examples/XXX/CMakeLists.txt
file (GLOB examples_sbudirs */CMakeLists.txt)
# Extract only relevant XXX and append it to PCL_EXAMPLES_SUBDIRS
foreach(subdir ${examples_sbudirs})
  # PATH of get_filename_component has problem dealing with windows shared folders "//xxx.xxx.xxx.xxx/folder"
  # Check here for the discussion: http://www.pcl-developers.org/Small-hack-to-get-filename-component-td5706691.html
  # Modified by Yangyan Li(yangyan.lee@gmail.com)
  # get_filename_component (dir ${subdir} PATH)
  get_filename_component (absolute ${subdir} ABSOLUTE)
  get_filename_component (name ${subdir} NAME)
  STRING(REGEX REPLACE ${name} "" dir ${absolute})
  list(APPEND PCL_EXAMPLES_SUBDIRS ${dir})
endforeach()

# Add the subdirectories
foreach(subdir ${PCL_EXAMPLES_SUBDIRS})
  add_subdirectory(${subdir})
endforeach()

if(CMAKE_GENERATOR_IS_IDE)
  set(SUBSYS_TARGET_NAME EXAMPLES_BUILD)
else()
  set(SUBSYS_TARGET_NAME ${SUBSYS_NAME})
endif()
add_custom_target(${SUBSYS_TARGET_NAME} DEPENDS ${PCL_EXAMPLES_ALL_TARGETS})
set_target_properties(${SUBSYS_TARGET_NAME} PROPERTIES FOLDER "Examples")

=== filters/CMakeLists.txt ===
set(SUBSYS_NAME filters)
set(SUBSYS_DESC "Point cloud filters library")
set(SUBSYS_DEPS common sample_consensus search kdtree octree)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/conditional_removal.cpp
  src/convolution.cpp
  src/crop_box.cpp
  src/extract_indices.cpp
  src/filter.cpp
  src/filter_indices.cpp
  src/passthrough.cpp
  src/shadowpoints.cpp
  src/project_inliers.cpp
  src/radius_outlier_removal.cpp
  src/random_sample.cpp
  src/normal_space.cpp
  src/sampling_surface_normal.cpp
  src/statistical_outlier_removal.cpp
  src/voxel_grid.cpp
  src/approximate_voxel_grid.cpp
  src/bilateral.cpp
  src/fast_bilateral.cpp
  src/fast_bilateral_omp.cpp
  src/crop_hull.cpp
  src/voxel_grid_covariance.cpp
  src/voxel_grid_label.cpp
  src/frustum_culling.cpp
  src/covariance_sampling.cpp
  src/median_filter.cpp
  src/uniform_sampling.cpp
  src/voxel_grid_occlusion_estimation.cpp
  src/normal_refinement.cpp
  src/grid_minimum.cpp
  src/morphological_filter.cpp
  src/local_maximum.cpp
  src/model_outlier_removal.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/conditional_removal.h"
  "include/pcl/${SUBSYS_NAME}/crop_box.h"
  "include/pcl/${SUBSYS_NAME}/clipper3D.h"
  "include/pcl/${SUBSYS_NAME}/plane_clipper3D.h"
  "include/pcl/${SUBSYS_NAME}/box_clipper3D.h"
  "include/pcl/${SUBSYS_NAME}/crop_hull.h"
  "include/pcl/${SUBSYS_NAME}/extract_indices.h"
  "include/pcl/${SUBSYS_NAME}/filter.h"
  "include/pcl/${SUBSYS_NAME}/filter_indices.h"
  "include/pcl/${SUBSYS_NAME}/passthrough.h"
  "include/pcl/${SUBSYS_NAME}/shadowpoints.h"
  "include/pcl/${SUBSYS_NAME}/project_inliers.h"
  "include/pcl/${SUBSYS_NAME}/radius_outlier_removal.h"
  "include/pcl/${SUBSYS_NAME}/random_sample.h"
  "include/pcl/${SUBSYS_NAME}/normal_space.h"
  "include/pcl/${SUBSYS_NAME}/sampling_surface_normal.h"
  "include/pcl/${SUBSYS_NAME}/statistical_outlier_removal.h"
  "include/pcl/${SUBSYS_NAME}/voxel_grid.h"
  "include/pcl/${SUBSYS_NAME}/approximate_voxel_grid.h"
  "include/pcl/${SUBSYS_NAME}/bilateral.h"
  "include/pcl/${SUBSYS_NAME}/fast_bilateral.h"
  "include/pcl/${SUBSYS_NAME}/fast_bilateral_omp.h"
  "include/pcl/${SUBSYS_NAME}/voxel_grid_covariance.h"
  "include/pcl/${SUBSYS_NAME}/convolution.h"
  "include/pcl/${SUBSYS_NAME}/convolution_3d.h"
  "include/pcl/${SUBSYS_NAME}/voxel_grid_label.h"
  "include/pcl/${SUBSYS_NAME}/voxel_grid_occlusion_estimation.h"
  "include/pcl/${SUBSYS_NAME}/frustum_culling.h"
  "include/pcl/${SUBSYS_NAME}/covariance_sampling.h"
  "include/pcl/${SUBSYS_NAME}/median_filter.h"
  "include/pcl/${SUBSYS_NAME}/uniform_sampling.h"
  "include/pcl/${SUBSYS_NAME}/normal_refinement.h"
  "include/pcl/${SUBSYS_NAME}/grid_minimum.h"
  "include/pcl/${SUBSYS_NAME}/morphological_filter.h"
  "include/pcl/${SUBSYS_NAME}/local_maximum.h"
  "include/pcl/${SUBSYS_NAME}/model_outlier_removal.h"
)
set(experimental_incs
  "include/pcl/${SUBSYS_NAME}/experimental/functor_filter.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/conditional_removal.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/crop_box.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/crop_hull.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/plane_clipper3D.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/box_clipper3D.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/extract_indices.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/filter.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/filter_indices.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/passthrough.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/shadowpoints.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/project_inliers.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/radius_outlier_removal.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/random_sample.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/normal_space.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/sampling_surface_normal.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/statistical_outlier_removal.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/voxel_grid.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/approximate_voxel_grid.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/bilateral.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/fast_bilateral.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/fast_bilateral_omp.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/voxel_grid_covariance.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/convolution.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/convolution_3d.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/voxel_grid_occlusion_estimation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/frustum_culling.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/covariance_sampling.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/median_filter.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/uniform_sampling.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/normal_refinement.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/grid_minimum.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/morphological_filter.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/local_maximum.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/model_outlier_removal.hpp"
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs})
target_link_libraries("${LIB_NAME}" pcl_common pcl_sample_consensus pcl_search pcl_kdtree pcl_octree)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/experimental" ${experimental_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== geometry/CMakeLists.txt ===
set(SUBSYS_NAME geometry)
set(SUBSYS_DESC "Point cloud geometry library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/eigen.h"
  "include/pcl/${SUBSYS_NAME}/get_boundary.h"
  "include/pcl/${SUBSYS_NAME}/line_iterator.h"
  "include/pcl/${SUBSYS_NAME}/mesh_base.h"
  "include/pcl/${SUBSYS_NAME}/mesh_circulators.h"
  "include/pcl/${SUBSYS_NAME}/mesh_conversion.h"
  "include/pcl/${SUBSYS_NAME}/mesh_elements.h"
  "include/pcl/${SUBSYS_NAME}/mesh_indices.h"
  "include/pcl/${SUBSYS_NAME}/mesh_io.h"
  "include/pcl/${SUBSYS_NAME}/mesh_traits.h"
  "include/pcl/${SUBSYS_NAME}/organized_index_iterator.h"
  "include/pcl/${SUBSYS_NAME}/planar_polygon.h"
  "include/pcl/${SUBSYS_NAME}/polygon_mesh.h"
  "include/pcl/${SUBSYS_NAME}/polygon_operations.h"
  "include/pcl/${SUBSYS_NAME}/quad_mesh.h"
  "include/pcl/${SUBSYS_NAME}/triangle_mesh.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/polygon_operations.hpp"
)


set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

add_library(${LIB_NAME} INTERFACE)
target_include_directories(${LIB_NAME} INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_link_libraries(${LIB_NAME} INTERFACE Boost::boost pcl_common)

PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} HEADER_ONLY)

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)
set(SUBSYS_EXT_DEPS boost eigen)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
if(WIN32)
  PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk rssdk rssdk2 pcap png vtk EXT_DEPS ${SUBSYS_EXT_DEPS})
else()
  PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk pcap png vtk libusb EXT_DEPS ${SUBSYS_EXT_DEPS})
endif()

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT WIN32)
  option(PCL_IO_ENABLE_MAND_LOCKING "Enables the use of mandatory locking on filesystems mounted using the mand option." ON)
  mark_as_advanced(PCL_IO_ENABLE_MAND_LOCKING)
  if(NOT PCL_IO_ENABLE_MAND_LOCKING)
    add_definitions(-DNO_MANDATORY_LOCKING)
  endif()
endif()

if(NOT build)
  return()
endif()

if(WITH_OPENNI2)
  set(IMAGE_INCLUDES
    include/pcl/io/image_metadata_wrapper.h
    include/pcl/io/image.h
    include/pcl/io/image_rgb24.h
    include/pcl/io/image_yuv422.h
    include/pcl/io/image_ir.h
    include/pcl/io/image_depth.h
  )

  set(IMAGE_SOURCES
    src/image_rgb24.cpp
    src/image_yuv422.cpp
    src/image_ir.cpp
    src/image_depth.cpp
  )

  set(OPENNI2_GRABBER_INCLUDES
    include/pcl/io/openni2_grabber.h
  )
  set(OPENNI2_INCLUDES
    include/pcl/io/openni2/openni.h
    include/pcl/io/openni2/openni2_metadata_wrapper.h
    include/pcl/io/openni2/openni2_frame_listener.h
    include/pcl/io/openni2/openni2_timer_filter.h
    include/pcl/io/openni2/openni2_video_mode.h
    include/pcl/io/openni2/openni2_convert.h
    include/pcl/io/openni2/openni2_device.h
    include/pcl/io/openni2/openni2_device_info.h
    include/pcl/io/openni2/openni2_device_manager.h
  )

  set(OPENNI2_GRABBER_SOURCES
    src/openni2_grabber.cpp
    src/openni2/openni2_timer_filter.cpp
    src/openni2/openni2_video_mode.cpp
    src/openni2/openni2_convert.cpp
    src/openni2/openni2_device.cpp
    src/openni2/openni2_device_info.cpp
    src/openni2/openni2_device_manager.cpp
  )

  source_group("OpenNI 2\\Header Files" FILES ${OPENNI2_GRABBER_INCLUDES} ${OPENNI2_INCLUDES} ${IMAGE_INCLUDES})
  source_group("OpenNI 2\\Source Files" FILES ${OPENNI2_GRABBER_SOURCES} ${IMAGE_SOURCES})

  # Copy OpenNI2 redist directory to bin. Needed for driver modules. Only tested on Windows.
  if(MSVC)
    file(COPY ${OPENNI2_REDIST_DIR} DESTINATION ${CMAKE_BINARY_DIR}/bin PATTERN *.*)
  endif()
endif()

if(WITH_OPENNI)
  set(OPENNI_GRABBER_INCLUDES
    include/pcl/io/openni_grabber.h
    include/pcl/io/oni_grabber.h
  )

  set(OPENNI_INCLUDES
    include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
    include/pcl/io/openni_camera/openni.h
    include/pcl/io/openni_camera/openni_depth_image.h
    include/pcl/io/openni_camera/openni_device.h
    include/pcl/io/openni_camera/openni_device_kinect.h
    include/pcl/io/openni_camera/openni_device_primesense.h
    include/pcl/io/openni_camera/openni_device_xtion.h
    include/pcl/io/openni_camera/openni_device_oni.h
    include/pcl/io/openni_camera/openni_driver.h
    include/pcl/io/openni_camera/openni_exception.h
    include/pcl/io/openni_camera/openni_image.h
    include/pcl/io/openni_camera/openni_image_bayer_grbg.h
    include/pcl/io/openni_camera/openni_image_yuv_422.h
    include/pcl/io/openni_camera/openni_image_rgb24.h
    include/pcl/io/openni_camera/openni_ir_image.h
     ${IMAGE_INCLUDES}
  )
  set(OPENNI_GRABBER_SOURCES
    src/openni_camera/openni_device.cpp
    src/openni_camera/openni_device_primesense.cpp
    src/openni_camera/openni_image_bayer_grbg.cpp
    src/openni_camera/openni_depth_image.cpp
    src/openni_camera/openni_ir_image.cpp
    src/openni_camera/openni_device_kinect.cpp
    src/openni_camera/openni_device_xtion.cpp
    src/openni_camera/openni_device_oni.cpp
    src/openni_camera/openni_driver.cpp
    src/openni_camera/openni_exception.cpp
    src/openni_camera/openni_image_yuv_422.cpp
    src/openni_camera/openni_image_rgb24.cpp
    src/openni_grabber.cpp
    src/oni_grabber.cpp
    ${IMAGE_SOURCES}
  )
endif()

source_group("Image Headers" FILES ${IMAGE_INCLUDES})
source_group("Image Sources" FILES ${IMAGE_SOURCES})

if(WITH_ENSENSO)
  set(ENSENSO_GRABBER_INCLUDES
    include/pcl/io/ensenso_grabber.h
  )
  set(ENSENSO_GRABBER_SOURCES
    src/ensenso_grabber.cpp
  )
endif()

if(WITH_DAVIDSDK AND VTK_FOUND) # VTK is mandatory for OBJ/PLY/STL input/output
  set(DAVIDSDK_GRABBER_INCLUDES
    include/pcl/io/davidsdk_grabber.h
  )
  set(DAVIDSDK_GRABBER_SOURCES
    src/davidsdk_grabber.cpp
  )
endif()

if(WITH_DSSDK)
  set(DSSDK_GRABBER_INCLUDES
    include/pcl/io/depth_sense_grabber.h
  )
  set(DSSDK_GRABBER_SOURCES
    src/depth_sense_grabber.cpp
    src/depth_sense/depth_sense_grabber_impl.cpp
    src/depth_sense/depth_sense_device_manager.cpp
  )
endif()

if(WITH_RSSDK)
  set(RSSDK_GRABBER_INCLUDES
    include/pcl/io/real_sense_grabber.h
  )
  set(RSSDK_GRABBER_SOURCES
    src/real_sense_grabber.cpp
    src/real_sense/real_sense_device_manager.cpp
  )
endif()

if(WITH_RSSDK2)
  set(RSSDK2_GRABBER_INCLUDES
      include/pcl/io/real_sense_2_grabber.h
  )
  set(RSSDK2_GRABBER_SOURCES
      src/real_sense_2_grabber.cpp
  )
endif()

if(LIBUSB_FOUND)
  set(DINAST_GRABBER_INCLUDES
    include/pcl/io/dinast_grabber.h
  )
  set(DINAST_GRABBER_SOURCES
    src/dinast_grabber.cpp
  )
endif()

if(VTK_FOUND AND NOT ANDROID)
  set(VTK_IO_INCLUDES
    "include/pcl/${SUBSYS_NAME}/vtk_lib_io.h"
    "include/pcl/${SUBSYS_NAME}/png_io.h"
  )
  set(VTK_IO_INCLUDES_IMPL
    "include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp"
  )
  set(VTK_IO_SOURCE
    src/vtk_lib_io.cpp
    src/png_io.cpp
  )

  # Indicates that we can rely on VTK to be present
  set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
endif()

set(PLY_SOURCES src/ply/ply_parser.cpp)
set(PLY_INCLUDES
  "include/pcl/${SUBSYS_NAME}/ply/byte_order.h"
  "include/pcl/${SUBSYS_NAME}/ply/io_operators.h"
  "include/pcl/${SUBSYS_NAME}/ply/ply.h"
  "include/pcl/${SUBSYS_NAME}/ply/ply_parser.h"
)

PCL_ADD_LIBRARY(pcl_io_ply COMPONENT ${SUBSYS_NAME} SOURCES ${PLY_SOURCES} ${PLY_INCLUDES})
if(MINGW)
  # libws2_32 isn't added by default for MinGW
  target_link_libraries(pcl_io_ply ws2_32)
endif()
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ply" ${PLY_INCLUDES})
target_include_directories(pcl_io_ply PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_link_libraries(pcl_io_ply Boost::boost)

set(srcs
  src/debayer.cpp
  src/pcd_grabber.cpp
  src/pcd_io.cpp
  src/vtk_io.cpp
  src/ply_io.cpp
  src/ascii_io.cpp
  src/compression.cpp
  src/lzf.cpp
  src/lzf_image_io.cpp
  src/obj_io.cpp
  src/ifs_io.cpp
  src/image_grabber.cpp
  src/hdl_grabber.cpp
  src/vlp_grabber.cpp
  src/robot_eye_grabber.cpp
  src/auto_io.cpp
  src/io_exception.cpp
  src/tim_grabber.cpp
  ${VTK_IO_SOURCE}
  ${OPENNI_GRABBER_SOURCES}
  ${OPENNI2_GRABBER_SOURCES}
  ${IMAGE_SOURCES}
  ${DINAST_GRABBER_SOURCES}
  ${ENSENSO_GRABBER_SOURCES}
  ${DAVIDSDK_GRABBER_SOURCES}
  ${DSSDK_GRABBER_SOURCES}
  ${RSSDK_GRABBER_SOURCES}
  ${RSSDK2_GRABBER_SOURCES}
)

if(PNG_FOUND)
  list(APPEND srcs
    src/libpng_wrapper.cpp
  )
endif()

if(PCAP_FOUND)
  set(PCAP_DEFINES -DHAVE_PCAP)
  include_directories(SYSTEM ${PCAP_INCLUDE_DIRS})
  add_definitions(${PCAP_DEFINES})
endif()

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/eigen.h"
  "include/pcl/${SUBSYS_NAME}/debayer.h"
  "include/pcl/${SUBSYS_NAME}/fotonic_grabber.h"
  "include/pcl/${SUBSYS_NAME}/file_io.h"
  "include/pcl/${SUBSYS_NAME}/auto_io.h"
  "include/pcl/${SUBSYS_NAME}/low_level_io.h"
  "include/pcl/${SUBSYS_NAME}/lzf.h"
  "include/pcl/${SUBSYS_NAME}/lzf_image_io.h"
  "include/pcl/${SUBSYS_NAME}/io.h"
  "include/pcl/${SUBSYS_NAME}/grabber.h"
  "include/pcl/${SUBSYS_NAME}/file_grabber.h"
  "include/pcl/${SUBSYS_NAME}/pcd_grabber.h"
  "include/pcl/${SUBSYS_NAME}/pcd_io.h"
  "include/pcl/${SUBSYS_NAME}/vtk_io.h"
  "include/pcl/${SUBSYS_NAME}/ply_io.h"
  "include/pcl/${SUBSYS_NAME}/tar.h"
  "include/pcl/${SUBSYS_NAME}/obj_io.h"
  "include/pcl/${SUBSYS_NAME}/ascii_io.h"
  "include/pcl/${SUBSYS_NAME}/ifs_io.h"
  "include/pcl/${SUBSYS_NAME}/image_grabber.h"
  "include/pcl/${SUBSYS_NAME}/hdl_grabber.h"
  "include/pcl/${SUBSYS_NAME}/vlp_grabber.h"
  "include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h"
  "include/pcl/${SUBSYS_NAME}/point_cloud_image_extractors.h"
  "include/pcl/${SUBSYS_NAME}/io_exception.h"
  "include/pcl/${SUBSYS_NAME}/tim_grabber.h"
  ${VTK_IO_INCLUDES}
  ${OPENNI_GRABBER_INCLUDES}
  ${OPENNI2_GRABBER_INCLUDES}
  ${IMAGE_INCLUDES}
  ${DINAST_GRABBER_INCLUDES}
  ${ENSENSO_GRABBER_INCLUDES}
  ${DAVIDSDK_GRABBER_INCLUDES}
  ${DSSDK_GRABBER_INCLUDES}
  ${RSSDK_GRABBER_INCLUDES}
  ${RSSDK2_GRABBER_INCLUDES}
)

set(compression_incs
  include/pcl/compression/octree_pointcloud_compression.h
  include/pcl/compression/color_coding.h
  include/pcl/compression/compression_profiles.h
  include/pcl/compression/entropy_range_coder.h
  include/pcl/compression/point_coding.h
)

if(PNG_FOUND)
  list(APPEND compression_incs
    include/pcl/compression/organized_pointcloud_conversion.h
    include/pcl/compression/libpng_wrapper.h
  )
  if(WITH_OPENNI OR WITH_OPENNI2)
  list(APPEND compression_incs
    include/pcl/compression/organized_pointcloud_compression.h
  )
  endif()
endif()

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/ascii_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/auto_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/point_cloud_image_extractors.hpp"
  include/pcl/compression/impl/entropy_range_coder.hpp
  include/pcl/compression/impl/octree_pointcloud_compression.hpp
  ${VTK_IO_INCLUDES_IMPL}
)

if(PNG_FOUND AND (WITH_OPENNI OR WITH_OPENNI2))
  list(APPEND impl_incs
    include/pcl/compression/impl/organized_pointcloud_compression.hpp
  )
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")

add_definitions(${VTK_DEFINES})

PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES} ${OPENNI2_INCLUDES})

target_include_directories(${LIB_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

target_link_libraries("${LIB_NAME}" Boost::boost Boost::filesystem Boost::iostreams pcl_common pcl_io_ply)

if(VTK_FOUND)
  if(${VTK_VERSION} VERSION_GREATER_EQUAL 9.0)
    target_link_libraries("${LIB_NAME}" 
                          VTK::IOImage
                          VTK::IOGeometry
                          VTK::IOPLY)
  else()
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries("${LIB_NAME}"
                          vtkIOImage
                          vtkIOGeometry
                          vtkIOMPIImage
                          vtkIOMPIParallel
                          vtkIOPLY
                          )
    if(${VTK_VERSION} VERSION_GREATER_EQUAL 7.0 AND ${VTK_VERSION} VERSION_LESS 8.0)
      target_link_libraries("${LIB_NAME}" vtkFiltersParallelDIY2)
    endif()
  endif()
endif()

if(PNG_FOUND)
  target_link_libraries("${LIB_NAME}" ${PNG_LIBRARIES})
endif()

if(LIBUSB_FOUND)
  target_link_libraries("${LIB_NAME}" libusb::libusb)
endif()

if(WITH_OPENNI2)
  target_link_libraries(${LIB_NAME} ${OPENNI2_LIBRARIES})
endif()

if(WITH_OPENNI)
  target_link_libraries("${LIB_NAME}" ${OPENNI_LIBRARIES})
  if(VTK_FOUND AND (NOT ${VTK_VERSION} VERSION_LESS 9.0))
    target_link_libraries("${LIB_NAME}" VTK::FiltersCore VTK::FiltersGeneral)
  endif()
endif()

if(WITH_FZAPI)
  target_link_libraries("${LIB_NAME}" ${FZAPI_LIBS})
  if(WIN32)
  target_link_libraries("${LIB_NAME}" Version.lib)
  endif()
endif()

if(WITH_ENSENSO)
  target_link_libraries(${LIB_NAME} ${ENSENSO_LIBRARIES})
endif()

if(WITH_DAVIDSDK)
  target_link_libraries(${LIB_NAME} ${DAVIDSDK_LIBRARIES})
endif()

if(WITH_DSSDK)
  target_link_libraries(${LIB_NAME} ${DSSDK_LIBRARIES})

=== kdtree/CMakeLists.txt ===
set(SUBSYS_NAME kdtree)
set(SUBSYS_DESC "Point cloud kd-tree library")
set(SUBSYS_DEPS common)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS} EXT_DEPS flann)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/kdtree_flann.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/kdtree.h"
  "include/pcl/${SUBSYS_NAME}/io.h"
  "include/pcl/${SUBSYS_NAME}/kdtree_flann.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/kdtree_flann.hpp"
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs})
target_link_libraries("${LIB_NAME}" pcl_common FLANN::FLANN)
set(EXT_DEPS flann)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== outofcore/CMakeLists.txt ===
set(SUBSYS_NAME outofcore)
set(SUBSYS_DESC "Point cloud outofcore library")
set(SUBSYS_DEPS common io filters octree visualization)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/cJSON.cpp
  src/outofcore_node_data.cpp
  src/outofcore_base_data.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/metadata.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_base_data.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_node_data.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_iterator_base.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_breadth_first_iterator.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_depth_first_iterator.h"
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/cJSON.h"
  "include/pcl/${SUBSYS_NAME}/octree_base.h"
  "include/pcl/${SUBSYS_NAME}/octree_base_node.h"
  "include/pcl/${SUBSYS_NAME}/octree_abstract_node_container.h"
  "include/pcl/${SUBSYS_NAME}/octree_disk_container.h"
  "include/pcl/${SUBSYS_NAME}/octree_ram_container.h"
  "include/pcl/${SUBSYS_NAME}/outofcore.h"
  "include/pcl/${SUBSYS_NAME}/outofcore_impl.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/outofcore_breadth_first_iterator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/outofcore_depth_first_iterator.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_base.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_base_node.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_disk_container.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/octree_ram_container.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/monitor_queue.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/lru_cache.hpp"
)

set(visualization_incs
  "include/pcl/${SUBSYS_NAME}/visualization/axes.h"
  "include/pcl/${SUBSYS_NAME}/visualization/camera.h"
  "include/pcl/${SUBSYS_NAME}/visualization/common.h"
  "include/pcl/${SUBSYS_NAME}/visualization/geometry.h"
  "include/pcl/${SUBSYS_NAME}/visualization/grid.h"
  "include/pcl/${SUBSYS_NAME}/visualization/object.h"
  "include/pcl/${SUBSYS_NAME}/visualization/outofcore_cloud.h"
  "include/pcl/${SUBSYS_NAME}/visualization/scene.h"
  "include/pcl/${SUBSYS_NAME}/visualization/viewport.h"
)

# Code in subdirectory `visualization` may use deprecated declarations when using OpenGLv1
# Add the GCC exclusive rules for -Werror only for OpenGLv1 compile to avoid build interruption
if(VTK_RENDERING_BACKEND_OPENGL_VERSION VERSION_LESS 2)
  if(CMAKE_COMPILER_IS_GNUCXX)
    add_compile_options("-Wno-error=deprecated-declarations")
  endif()
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs} ${visualization_incs})
#PCL_ADD_SSE_FLAGS("${LIB_NAME}")
target_link_libraries("${LIB_NAME}" pcl_common pcl_visualization ${Boost_SYSTEM_LIBRARY})
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/visualization" ${visualization_incs})

if(BUILD_tools)
  add_subdirectory(tools)
endif()

=== recognition/CMakeLists.txt ===
set(SUBSYS_NAME recognition)
set(SUBSYS_DESC "Point cloud recognition library")
set(SUBSYS_DEPS common io search kdtree octree features filters registration sample_consensus ml)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build "${SUBSYS_NAME}" DEPS ${SUBSYS_DEPS})

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(LINEMOD_INCLUDES
  "include/pcl/${SUBSYS_NAME}/linemod/line_rgbd.h"
)

set(LINEMOD_IMPLS
  "include/pcl/${SUBSYS_NAME}/impl/linemod/line_rgbd.hpp"
)

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/color_gradient_dot_modality.h"
  "include/pcl/${SUBSYS_NAME}/color_gradient_modality.h"
  "include/pcl/${SUBSYS_NAME}/color_modality.h"
  "include/pcl/${SUBSYS_NAME}/crh_alignment.h"
  "include/pcl/${SUBSYS_NAME}/linemod.h"
  "include/pcl/${SUBSYS_NAME}/dotmod.h"
  "include/pcl/${SUBSYS_NAME}/quantizable_modality.h"
  "include/pcl/${SUBSYS_NAME}/quantized_map.h"
  "include/pcl/${SUBSYS_NAME}/dot_modality.h"
  "include/pcl/${SUBSYS_NAME}/region_xy.h"
  "include/pcl/${SUBSYS_NAME}/mask_map.h"
  "include/pcl/${SUBSYS_NAME}/point_types.h"
  "include/pcl/${SUBSYS_NAME}/distance_map.h"
  "include/pcl/${SUBSYS_NAME}/dense_quantized_multi_mod_template.h"
  "include/pcl/${SUBSYS_NAME}/sparse_quantized_multi_mod_template.h"
  "include/pcl/${SUBSYS_NAME}/surface_normal_modality.h"
  "include/pcl/${SUBSYS_NAME}/line_rgbd.h"
  "include/pcl/${SUBSYS_NAME}/implicit_shape_model.h"
  "include/pcl/${SUBSYS_NAME}/auxiliary.h"
  "include/pcl/${SUBSYS_NAME}/hypothesis.h"
  "include/pcl/${SUBSYS_NAME}/model_library.h"
  "include/pcl/${SUBSYS_NAME}/rigid_transform_space.h"
  "include/pcl/${SUBSYS_NAME}/obj_rec_ransac.h"
  "include/pcl/${SUBSYS_NAME}/orr_graph.h"
  "include/pcl/${SUBSYS_NAME}/orr_octree_zprojection.h"
  "include/pcl/${SUBSYS_NAME}/trimmed_icp.h"
  "include/pcl/${SUBSYS_NAME}/orr_octree.h"
  "include/pcl/${SUBSYS_NAME}/simple_octree.h"
  "include/pcl/${SUBSYS_NAME}/voxel_structure.h"
  "include/pcl/${SUBSYS_NAME}/bvh.h"
)

set(ransac_based_incs
  "include/pcl/${SUBSYS_NAME}/ransac_based/auxiliary.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/hypothesis.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/model_library.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/rigid_transform_space.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/obj_rec_ransac.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_graph.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree_zprojection.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/trimmed_icp.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/orr_octree.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/simple_octree.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/voxel_structure.h"
  "include/pcl/${SUBSYS_NAME}/ransac_based/bvh.h"
)

set(hv_incs
  "include/pcl/${SUBSYS_NAME}/hv/occlusion_reasoning.h"
  "include/pcl/${SUBSYS_NAME}/hv/hypotheses_verification.h"
  "include/pcl/${SUBSYS_NAME}/hv/hv_papazov.h"
  "include/pcl/${SUBSYS_NAME}/hv/hv_go.h"
  "include/pcl/${SUBSYS_NAME}/hv/greedy_verification.h"
)

set(face_detection_incs
  "include/pcl/${SUBSYS_NAME}/face_detection/face_common.h"
  "include/pcl/${SUBSYS_NAME}/face_detection/face_detector_data_provider.h"
  "include/pcl/${SUBSYS_NAME}/face_detection/rf_face_detector_trainer.h"
  "include/pcl/${SUBSYS_NAME}/face_detection/rf_face_utils.h"
)

set(cg_incs
  "include/pcl/${SUBSYS_NAME}/cg/correspondence_grouping.h"
  "include/pcl/${SUBSYS_NAME}/cg/hough_3d.h"
  "include/pcl/${SUBSYS_NAME}/cg/geometric_consistency.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/line_rgbd.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/simple_octree.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/voxel_structure.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/implicit_shape_model.hpp"
)

set(ransac_based_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/ransac_based/simple_octree.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/ransac_based/voxel_structure.hpp"
)

set(hv_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/hv/occlusion_reasoning.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/hv/hv_papazov.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/hv/greedy_verification.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/hv/hv_go.hpp"
)

set(cg_impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/cg/correspondence_grouping.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cg/hough_3d.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cg/geometric_consistency.hpp"
)

set(srcs
  src/linemod.cpp
  src/quantizable_modality.cpp
  src/dotmod.cpp
  src/mask_map.cpp
  src/hv/occlusion_reasoning.cpp
  src/hv/hv_papazov.cpp
  src/hv/hv_go.cpp
  src/hv/greedy_verification.cpp
  src/cg/hough_3d.cpp
  src/cg/geometric_consistency.cpp
  src/ransac_based/obj_rec_ransac.cpp
  src/ransac_based/model_library.cpp
  src/ransac_based/orr_octree.cpp
  src/ransac_based/orr_octree_zprojection.cpp
  src/face_detection/face_detector_data_provider.cpp
  src/face_detection/rf_face_detector_trainer.cpp
  src/implicit_shape_model.cpp
)

if(HAVE_METSLIB)
  set(metslib_incs "")
else()
  set(metslib_incs
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/abstract-search.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/local-search.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/mets.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/metslib_config.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/model.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/observer.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/simulated-annealing.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/tabu-search.hh"
    "include/pcl/${SUBSYS_NAME}/3rdparty/metslib/termination-criteria.hh"
  )
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs} ${face_detection_incs} ${ransac_based_incs} ${ransac_based_impl_incs} ${hv_incs} ${hv_impl_incs} ${cg_incs} ${cg_impl_incs} ${metslib_incs})
target_link_libraries("${LIB_NAME}" pcl_common pcl_kdtree pcl_octree pcl_search pcl_features pcl_registration pcl_sample_consensus pcl_filters pcl_ml pcl_io)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})
# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ransac_based" ${ransac_based_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/hv" ${hv_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/cg" ${cg_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/face_detection" ${face_detection_incs})

PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/ransac_based" ${ransac_based_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/hv" ${hv_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/cg" ${cg_impl_incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/linemod" ${LINEMOD_INCLUDES})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl/linemod" ${LINEMOD_IMPLS})

if(NOT HAVE_METSLIB)
  PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/3rdparty/metslib" ${metslib_incs})
endif()

=== debian/changelog ===
pcl (1.12.1+dfsg-5ubuntu1) kinetic; urgency=medium

  * Override dh_dwz for architectures building with clang
  * Reduce parallelism to avoid OOM on Launchpad builders

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 06 Sep 2022 11:40:40 +0000

pcl (1.12.1+dfsg-5) unstable; urgency=medium

  * Add upstream patch to fix build on armhf

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 19 Aug 2022 13:41:49 +0200

pcl (1.12.1+dfsg-4) unstable; urgency=medium

  * Add upstream source
  * Temporary add depends for #1013316
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 13 Jul 2022 15:20:25 +0200

pcl (1.12.1+dfsg-3) unstable; urgency=medium

  * Add missing dependency (Closes: #1002786)
  * Add patch for wrong boost pkg-config dependency (Closes: #1002753)

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 29 Dec 2021 10:52:53 +0100

pcl (1.12.1+dfsg-2) unstable; urgency=medium

  * Fix more unit tests on i386

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 25 Dec 2021 15:01:23 +0100

pcl (1.12.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.12.1+dfsg
  * Rebase patches
  * Update copyright
  * Drop empty documentation
  * Add patch to drop build path in cmake file

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 24 Dec 2021 23:58:00 +0100

pcl (1.12.0+dfsg-6) unstable; urgency=medium

  * Fix ppc64 in d/rules
  * Fix double space
  * Add patch for failing tests

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 13 Dec 2021 22:14:52 +0100

pcl (1.12.0+dfsg-5) unstable; urgency=medium

  * upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 11 Oct 2021 21:43:17 +0200

pcl (1.12.0+dfsg-4) experimental; urgency=medium

  * Only run tests if they are enabled
  * Fix tests on armel

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 10 Oct 2021 11:23:52 +0200

pcl (1.12.0+dfsg-3) experimental; urgency=medium

  * Fix preprocessor syntax

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 09 Oct 2021 17:38:10 +0200

pcl (1.12.0+dfsg-2) experimental; urgency=medium

  * Fix build and disable failing tests

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 09 Oct 2021 16:59:23 +0200

pcl (1.12.0+dfsg-1) experimental; urgency=medium

  * New upstream version 1.12.0+dfsg
    - Switch to Qhull reentrant (Closes: #990399)
    - Fix PCLConfig.cmake (LP: #1928819)
  * Switch to VTK9
  * Update copyright
  * Rebase patches
  * Use /tags in d/watch
  * Bump policy version (no changes)
  * Remove unused manpages
  * Rename binary package due to Soversion bump
  * Install examples
  * Simplify rules, run tests
  * Add patch to set LD_LIBRARY_PATH for tests
  * Add patch to disable failing tests
  * Add d/clean
  * Cleanup

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 02 Oct 2021 12:29:30 +0200

=== debian/control ===
Source: pcl
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
	       clang [mipsel armel armhf],
	       libstdc++-12-dev [mipsel armel armhf],
	       python3-sphinx,
	       libboost-system-dev,
	       libboost-filesystem-dev,
	       libboost-thread-dev,
	       libboost-date-time-dev,
	       libboost-iostreams-dev,
	       libeigen3-dev,
	       libflann-dev,
	       libvtk9-dev,
	       libqhull-dev,
	       libopenni-dev [!s390x !alpha !hppa !hurd-i386 !ia64 !kfreebsd-any !m68k !riscv64 !sh4 !sparc64],
	       libopenni2-dev [!hurd-i386 !hppa !kfreebsd-any],
	       libqt5opengl5-dev,
	       libusb-1.0-0-dev,
	       freeglut3-dev,
	       libxmu-dev,
	       libxi-dev,
	       libpcap-dev,
	       libvtk9-qt-dev,
	       libglew-dev,
	       libgtest-dev,
Build-Depends-Indep: doxygen,
		     doxygen-latex
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/pcl
Vcs-Git: https://salsa.debian.org/science-team/pcl.git
Rules-Requires-Root: no
Homepage: http://www.pointclouds.org/

Package: libpcl-dev
Architecture: any
Section: libdevel
Depends: libboost-all-dev,
	 libeigen3-dev,
	 libflann-dev,
	 libvtk9-dev,
	 libqhull-dev,
	 libvtk9-qt-dev,
	 libusb-1.0-0-dev,
	 libopenni-dev [!s390x !alpha !hppa !hurd-i386 !ia64 !kfreebsd-any !m68k !riscv64 !sh4 !sparc64],
	 libopenni2-dev [!hurd-i386 !hppa !kfreebsd-any],
	 libpcl-apps1.12 (= ${binary:Version}),
	 libpcl-common1.12 (= ${binary:Version}),
	 libpcl-features1.12 (= ${binary:Version}),
	 libpcl-filters1.12 (= ${binary:Version}),
	 libpcl-io1.12 (= ${binary:Version}),
	 libpcl-kdtree1.12 (= ${binary:Version}),
	 libpcl-keypoints1.12 (= ${binary:Version}),
	 libpcl-ml1.12 (= ${binary:Version}),
	 libpcl-octree1.12 (= ${binary:Version}),
	 libpcl-outofcore1.12 (= ${binary:Version}),
	 libpcl-people1.12 (= ${binary:Version}),
	 libpcl-recognition1.12 (= ${binary:Version}),
	 libpcl-registration1.12 (= ${binary:Version}),
	 libpcl-sample-consensus1.12 (= ${binary:Version}),
	 libpcl-search1.12 (= ${binary:Version}),
	 libpcl-segmentation1.12 (= ${binary:Version}),
	 libpcl-stereo1.12 (= ${binary:Version}),
	 libpcl-surface1.12 (= ${binary:Version}),
	 libpcl-tracking1.12 (= ${binary:Version}),
	 libpcl-visualization1.12 (= ${binary:Version}),
	 ${misc:Depends}
Suggests: libpcl-doc
Breaks: libvtk6-dev,
        libvtk6-java,
        libvtk6-jni,
        libvtk6-qt-dev,
Description: Point Cloud Library - development files
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains development files (headers and shared library
 symbolic link).

Package: libpcl-apps1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - apps library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications depending
 on PCL apps.

Package: libpcl-common1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - common library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL common library.

Package: libpcl-features1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - features library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL features library.

Package: libpcl-filters1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - filters library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL filters library.

Package: libpcl-io1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - I/O library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the libraries needed to run applications
 depending on PCL io.

Package: libpcl-kdtree1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - kdtree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL kdtree library.

Package: libpcl-keypoints1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - keypoints library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL keypoints library.

Package: libpcl-ml1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - ml library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL ml library.

Package: libpcl-octree1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - octree library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL octree library.

Package: libpcl-outofcore1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: Point Cloud Library - outofcore library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications
 depending on PCL outofcore.

Package: libpcl-people1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: Point Cloud Library - people library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications
 depending on PCL people.

Package: libpcl-recognition1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
    	 ${misc:Depends}
Description: Point Cloud Library - recognition library
 The PCL framework contains numerous state-of-the art algorithms including
 filtering, feature estimation, surface reconstruction, registration, model
 fitting and segmentation.
 .
 This package contains the libraries needed to run applications
 depending on PCL recognition.

Package: libpcl-registration1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - registration library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL registration library.

Package: libpcl-sample-consensus1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - sample consensus library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL sample consensus library.

Package: libpcl-search1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - search library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL search library.

Package: libpcl-segmentation1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - segmentation library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.
 .
 This package contains the PCL segmentation library.

Package: libpcl-stereo1.12
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Cloud Library - stereo library
 The Point Cloud Library (PCL) is a standalone, large scale, open

=== debian/rules ===
#!/usr/bin/make -f

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -g1

BUILD_DOC = $(if $(shell dh_listpackages | grep libpcl-doc),-DWITH_DOCS=ON)

ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel armhf armel))
  PARALLEL=--max-parallel=2
  export CC=/usr/bin/clang
  export CXX=/usr/bin/clang++
else
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 ppc64el s390x))
  PARALLEL=--max-parallel=3
else
  PARALLEL=
endif
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),s390x powerpc ppc64 riscv64))
  RUN_TESTS=
else
  RUN_TESTS=-DBUILD_global_tests=ON -DBUILD_TESTS=ON

override_dh_auto_test:
	make -C obj-${DEB_HOST_GNU_TYPE} tests

endif

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DLIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)"		\
	-DCMAKE_SKIP_RPATH=ON -DPCL_ENABLE_SSE=OFF			\
	-DBUILD_apps_in_hand_scanner=ON \
	-DBUILD_apps_modeler=ON \
	-DBUILD_apps=ON \
	-DBUILD_apps_point_cloud_editor=ON \
	-DPCL_DISABLE_GPU_TESTS=ON \
	$(BUILD_DOC) $(RUN_TESTS)

%:
	dh $@ $(PARALLEL)

ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel armhf armel))
override_dh_dwz:
endif
